-- Shield thinkers for Silver.

-- List of thinkers are:
/*
	-boostThink 	(mobj_t mo)		-> runs during boost
	-boostDamage 	(boolean)		-> if false, then the boost isn't cancelled on damage
	-boostBump		(mobj_t mo)		-> runs when a wall gets bumped
	-boostSlideFire	(boolean)		-> if true, spawns a fire trail
	-boostWater		(boolean)		-> if true, immune to water slowdown
	-boostSneaker 	(boolean)		-> if true, the boost behaves as if you had super sneakers / super form
	-ico			(string lump)	-> icon
*/
/*
local whirltable = {
	boostThink = 	function(mo)
						mo.silv_energy = $+2
					end,
	ico = "ICO_WIND",
	icooffs = {-9, 0},
}
silv_addShieldStuff(SH_JUMP, whirltable)

local boomtable = {
	boostBump = 	function(mo)

						for i = 1, 128
							local t = P_SpawnMobj(mo.x, mo.y, mo.z, MT_THOK)
							t.scale = mo.scale
							t.momx = P_RandomRange(-34, 34)*mo.scale
							t.momy = P_RandomRange(-34, 34)*mo.scale
							t.momz = P_RandomRange(-34, 34)*mo.scale
							t.color = SKINCOLOR_TEAL
							t.scale = mo.scale
							t.scalespeed = mo.scale/12
							t.destscale = 1
						end
						S_StartSound(mo, sfx_s3k4e)
						P_NukeEnemies(mo, mo, 600*FRACUNIT)
					end,
	ico = "ICO_NUKE",
	icooffs = {-13, -6}
}
silv_addShieldStuff(SH_ARMAGEDDON, boomtable)

local forcetable = {
	boostDamage = false,
	ico = "ICO_SHLD",
	icooffs = {-11, -9},
}
silv_addShieldStuff(SH_FORCE, forcetable)

local elementaltable = {
	boostWater = true,
	boostSlideFire = true,
	ico = "ICO_ELEM",
	icooffs = {-9, 0}
}
silv_addShieldStuff(SH_ELEMENTAL, elementaltable)

local bubbletable = {
	boostWater = true,
}
silv_addShieldStuff(SH_BUBBLEWRAP, bubbletable)

freeslot("SPR_KLIT")
local attractiontable = {
	boostThink = 	function(mo)
						for i = 1, P_RandomRange(1, 4)
							local a = P_SpawnMobj(mo.x, mo.y, mo.z +mo.height/4, MT_THOK)
							a.sprite = SPR_KLIT
							a.scale = mo.scale*2/3
							a.frame = P_RandomRange(0, P) |FF_FULLBRIGHT
							a.tics = 1
							a.momx, a.momy, a.momz = mo.momx, mo.momy, mo.momz

							a = P_SpawnMobj(mo.x + P_RandomRange(-128, 128)*mo.scale, mo.y + P_RandomRange(-128, 128)*mo.scale, mo.z + P_RandomRange(-128, 128)*mo.scale, MT_THOK)
							a.target = mo
							A_HomingChase(a, 10*FRACUNIT)
							a.momx, a.momy, a.momz = $1+mo.momx, $2+mo.momy, $3+mo.momz
							a.fuse = 10
							a.scale = mo.scale/3
							a.destscale = 1
							a.state = S_MAGN1
						end

						local t = silv_getTKtable()
						for k,v in ipairs(t)
							if v and v.valid and v.flags & MF_ENEMY
								if R_PointToDist2(mo.x, mo.y, v.x, v.y) <= FixedMul(mo.scale, RING_DIST/3)
								and abs(mo.z - v.z) <= FixedMul(mo.scale, RING_DIST/3)
									v.target = mo
									A_HomingChase(v, 32*FRACUNIT)
									v.momx, v.momy, v.momz = $1+mo.momx, $2+mo.momy, $3+mo.momz
								end
							end
						end
					end,
	ico = "ICO_MAGN",
	icooffs = {-10, -5},
}
silv_addShieldStuff(SH_ATTRACT, attractiontable)

local thundertable = {
	boostThink = 	function(mo)
						mo.silv_energy = $+2
						for i = 1, P_RandomRange(1, 4)
							local a = P_SpawnMobj(mo.x, mo.y, mo.z +mo.height/4, MT_THOK)
							a.sprite = SPR_KLIT
							a.scale = mo.scale*2/3
							a.frame = P_RandomRange(0, P) |FF_FULLBRIGHT
							a.tics = 1
							a.momx, a.momy, a.momz = mo.momx, mo.momy, mo.momz

							a = P_SpawnMobj(mo.x + P_RandomRange(-128, 128)*mo.scale, mo.y + P_RandomRange(-128, 128)*mo.scale, mo.z + P_RandomRange(-128, 128)*mo.scale, MT_THOK)
							a.target = mo
							A_HomingChase(a, 10*FRACUNIT)
							a.momx, a.momy, a.momz = $1+mo.momx, $2+mo.momy, $3+mo.momz
							a.fuse = 10
							a.scale = mo.scale/3
							a.destscale = 1
							a.state = S_MAGN1
							a.colorized = true
							a.color = SKINCOLOR_AETHER
						end
					end,
	ico = "ICO_MAGN",
	icooffs = {-10, -5},
}
silv_addShieldStuff(SH_THUNDERCOIN, thundertable)

local flametable = {
	boostSneaker = true,
	boostThink = 	function(mo)
						if leveltime%2
							local fire = P_SpawnMobjFromMobj(mo, 0,0,0, MT_THOK)
							fire.scale = mo.scale
							fire.angle = mo.angle
							fire.tics = 2
							fire.sprite = SPR_FIRS
							fire.frame = S|FF_FULLBRIGHT
							fire.scale = mo.scale*3/2
						end
					end
}
silv_addShieldStuff(SH_FLAMEAURA, flametable)*/